<?php

// Set paths..
define('PATH', __dir__ . '/');
define('IPATH', __dir__ . '/../');
define('INC', 1);

if (version_compare(phpversion(), '7.0', '<')) {
  die('PHP version too old, PHPv7.0 or higher required');
}

// Start session
$ini_get = ini_get_all();
if (isset($ini_get['session.cookie_httponly'])) {
  ini_set('session.cookie_httponly', 1);
}
session_start();

// Load include files..
include(IPATH . 'control/functions.php');
include(PATH . 'control/functions.php');
if(file_exists(IPATH . 'control/_cfg.php')){include(IPATH . 'control/_cfg.php');}else{die('File "control/_cfg.php" is missing, please see installation instructions.');}


include(IPATH . 'control/lib/tracy/vendor/tracy/tracy/src/tracy.php');
use Tracy\Debugger;
// For development, report everything and enable tracy bar
Debugger::$showBar = (defined('DEVELOPMENT_ENV') ? true : false);
Debugger::$strictMode = (defined('DEVELOPMENT_ENV') ? true : false);
Debugger::enable(Debugger::DEVELOPMENT, IPATH . 'logs');

include(IPATH . 'content/lang/english.php');
include(PATH . 'control/constants.php');
include(PATH . 'control/classes/class.paginate.php');
include(PATH . 'control/classes/class.settings.php');
include(IPATH . 'control/classes/mailer/class.mail.php');

// Set timezone..
date_default_timezone_set((TIMEZONE ? TIMEZONE : date_default_timezone_get()));

// Initiate settings class..
$MAIL = new mailClass();
$STS  = new programSettings();

// Secure login token..
define('SEC_TOKEN', 'adm-panel-' . sha1(SECRET_KEY . sha1(SECRET_KEY)));

// Initiate vars..
$cmd        = (isset($_GET['cmd']) ? $_GET['cmd'] : 'home');
$page       = (isset($_GET['page']) ? (int) $_GET['page'] : '1');
$count      = 0;
$limit      = DATA_PER_PAGE;
$limitvalue = $page * $limit - ($limit);
$title      = $msg_script . ' ' . $msg_script2 . ' - ' . $msg_header;
$SETTINGS   = $STS->loadSettings();

// Default mail vars..
$MAIL->smtp_en   = $SETTINGS->smtp;
$MAIL->smtp_host = $SETTINGS->smtp_host;
$MAIL->smtp_user = $SETTINGS->smtp_user;
$MAIL->smtp_pass = $SETTINGS->smtp_pass;
$MAIL->smtp_port = $SETTINGS->smtp_port;
$MAIL->html      = SET_HTML;
$MAIL->addTag('{WEBSITE_NAME}', $SETTINGS->cfg_wname);
$MAIL->addTag('{WEBSITE_URL}', $SETTINGS->cfg_wurl);

// If password blank, update and reload..
if ($SETTINGS->cfg_password == '') {
  $_POST['user'] = 'admin';
  $STS->updatePassword('admin');
  header("Location: index.php");
  exit;
}

// Load templates..
switch ($cmd) {
  // Home..
  case 'home':

    isSessionActive();

    $title = $title . ' - ' . $msg_header2;

    include(PATH . 'content/header.php');
    include(PATH . 'content/home.php');
    include(PATH . 'content/footer.php');
    break;

  // Settings..
  case 'settings':

    isSessionActive();

    $title = $title . ' - ' . $msg_header8;

    if (isset($_POST['process'])) {
      $_POST = array_map('trim', $_POST);
      if ($_POST['cfg_wname'] == '') {
        $N_ERROR = $msg_settings6;
        $count++;
      }
      if (!preg_match("/^[_.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z.-]+.)+[a-zA-Z]{2,20}$/i", $_POST['cfg_wemail'])) {
        $E_ERROR = $msg_settings7;
        $count++;
      }
      if ($_POST['cfg_wurl'] == '') {
        $U_ERROR = $msg_settings8;
        $count++;
      }
      if ($count == 0) {
        $STS->updateSettings();
        header("Location: index.php?cmd=settings");
        exit;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/settings.php');
    include(PATH . 'content/footer.php');
    break;

  // Surveys..
  case 'surveys':
  case 'create-survey':
  case 'edit-survey':
  case 'copy-survey':
  case 'clear-results':

    isSessionActive();

    include(PATH . 'control/classes/class.surveys.php');
    $SVY = new surveys();

    switch ($cmd) {
      case 'surveys':
        $title = $title . ' - ' . $msg_header4;
        break;
      case 'create-survey':
        $title = $title . ' - ' . $msg_survey2;
        break;
      case 'edit-survey':
        $title = $title . ' - ' . $msg_survey23;
        break;
      case 'copy-survey':
        $title = $title . ' - ' . $msg_survey40;
        break;
      case 'clear-results':
        $title = $title . ' - ' . $msg_survey55;
        break;
    }

    // Add survey..
    if (isset($_POST['process'])) {
      $_POST = array_map('trim', $_POST);
      if ($SVY->checkTitle($_POST['sur_title']) || $_POST['sur_title'] == '') {
        $T_ERROR = ($_POST['sur_title'] == '' ? $msg_survey26 : $msg_survey25);
      } else {
        $SVY->addSurvey();
        $CREATED = true;
      }
    }

    // Edit survey..
    if (isset($_GET['edit']) || isset($_POST['edit'])) {
      $EDIT = $SVY->getSurvey(isset($_GET['edit']) ? $_GET['edit'] : $_POST['edit']);
      if (isset($_POST['edit'])) {
        $_POST = array_map('trim', $_POST);
        if ($SVY->checkTitle($_POST['sur_title'], $EDIT->sur_id) || $_POST['sur_title'] == '') {
          $T_ERROR = ($_POST['sur_title'] == '' ? $msg_survey26 : $msg_survey25);
        } else {
          $SVY->updateSurvey();
          $UPDATED = true;
        }
      }
    }

    // Copy survey..
    if (isset($_GET['copy']) || isset($_POST['copy'])) {
      $COPY = $SVY->getSurvey(isset($_GET['copy']) ? $_GET['copy'] : $_POST['copy']);
      if (isset($_POST['copy'])) {
        $_POST = array_map('trim', $_POST);
        if ($SVY->checkTitle($_POST['sur_title']) || $_POST['sur_title'] == '') {
          $T_ERROR = ($_POST['sur_title'] == '' ? $msg_survey26 : $msg_survey25);
        } else {
          $SVY->addSurvey();
          $COPIED = true;
        }
      }
    }

    // Preview survey..
    if (isset($_GET['preview'])) {
      header("Location: ../index.php?survey=" . $_GET['preview']);
      exit;
    }

    // Delete survey..
    if (isset($_GET['delete'])) {
      $SVY->deleteSurvey($_GET['delete']);
      header("Location: index.php?cmd=surveys");
      exit;
    }

    // Clear results..
    if ($cmd == 'clear-results') {
      $SVY->clearResults($_GET['survey']);
      include(PATH . 'content/header.php');
      include(PATH . 'content/' . $cmd . '.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    // Load options..
    if (isset($_GET['options'])) {
      $_SESSION['loadOptions'] = $_GET['options'];
      header("Location: index.php?cmd=surveys&reload=1");
      exit;
    } else {
      if (isset($_SESSION['loadOptions']) && !isset($_GET['reload']) && !isset($COPY)) {
        unset($_SESSION['loadOptions']);
        header("Location: index.php?cmd=surveys");
        exit;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/' . $cmd . '.php');
    include(PATH . 'content/footer.php');
    break;

  // Colour Schemes..
  case 'colours':
  case 'create-colour-scheme':
  case 'edit-colour-scheme':

    isSessionActive();

    include(PATH . 'control/classes/class.colors.php');
    $CLR = new colorSchemer();

    switch ($cmd) {
      case 'colours':
        $title = $title . ' - ' . $msg_header5;
        break;
      case 'create-colour-scheme':
        $title = $title . ' - ' . $msg_colours2;
        break;
      case 'edit-colour-scheme':
        $title = $title . ' - ' . $msg_colours18;
        break;
    }

    // Add scheme..
    if (isset($_POST['process'])) {
      $_POST = array_map('trim', $_POST);
      if ($CLR->checkTitle($_POST['csc_title']) || $_POST['csc_title'] == '') {
        $T_ERROR = ($_POST['csc_title'] == '' ? $msg_colours20 : $msg_colours17);
      } else {
        $CLR->addScheme();
        header("Location: index.php?cmd=colours");
        exit;
      }
    }

    // Edit scheme..
    if (isset($_GET['edit']) || isset($_POST['edit'])) {
      $EDIT = $CLR->getScheme(isset($_GET['edit']) ? $_GET['edit'] : $_POST['edit']);
      if (isset($_POST['edit'])) {
        $_POST = array_map('trim', $_POST);
        if ($CLR->checkTitle($_POST['csc_title'], $EDIT->csc_id) || $_POST['csc_title'] == '') {
          $T_ERROR = ($_POST['csc_title'] == '' ? $msg_colours20 : $msg_colours17);
        } else {
          $CLR->updateScheme();
          header("Location: index.php?cmd=edit-colour-scheme&edit=" . $EDIT->csc_id);
          exit;
        }
      }
    }

    // Preview scheme..
    if (isset($_GET['preview'])) {
      $PREVIEW = $CLR->getScheme($_GET['preview']);
      include(PATH . 'content/popup/preview-colour-scheme.php');
      exit;
    }

    // Delete scheme..
    if (isset($_GET['delete'])) {
      $CLR->deleteScheme($_GET['delete']);
      header("Location: index.php?cmd=colours");
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/' . $cmd . '.php');
    include(PATH . 'content/footer.php');
    break;

  // Questions..
  case 'questions':
  case 'add-question':
  case 'edit-question':

    isSessionActive();

    include(PATH . 'control/classes/class.questions.php');
    $QTN = new questions();

    switch ($cmd) {
      case 'questions':
        $title = $title . ' - ' . $msg_question;
        break;
      case 'add-question':
        $title = $title . ' - ' . $msg_question3;
        if (!isset($_GET['help'])) {
          $SUR = rowData('surveys', ' WHERE sur_id = \'' . (int) (isset($_POST['survey']) ? $_POST['survey'] : $_GET['survey']) . '\'');
        }
        break;
      case 'edit-question':
        $title = $title . ' - ' . $msg_question23;
        break;
    }

    // View help file..
    if (isset($_GET['help'])) {
      include(PATH . 'content/popup/answer-type.php');
      exit;
    }

    // Update order..
    if (isset($_POST['order'])) {
      $QTN->updateOrderByOptions();
      header("Location: index.php?cmd=questions&survey=" . $_POST['survey']);
      exit;
    }

    // Add question..
    if (isset($_POST['process'])) {
      $_POST = array_map('trim', $_POST);
      if ($_POST['que_text'] == '') {
        $Q_ERROR = $msg_question25;
      } else {
        $QTN->addQuestion();
        $CREATED = true;
      }
    }

    // Edit question..
    if (isset($_GET['edit']) || isset($_POST['edit'])) {
      $EDIT = $QTN->getQuestion(isset($_GET['edit']) ? $_GET['edit'] : $_POST['edit']);
      if (isset($EDIT->que_id)) {
        $VARIANTS = $QTN->getVariants($EDIT->que_id);
        $SUR      = rowData('surveys', ' WHERE sur_id = \'' . $EDIT->que_sur_id . '\'');
        if (isset($_POST['edit'])) {
          $_POST = array_map('trim', $_POST);
          if ($_POST['que_text'] == '') {
            $Q_ERROR = $msg_question25;
          } else {
            $QTN->updateQuestion();
            $UPDATED = true;
          }
        }
      }
    }

    // Delete questions..
    if (isset($_GET['delete'])) {
      $QTN->deleteQuestion($_GET['delete']);
      header("Location: index.php?cmd=questions&survey=" . $_GET['survey']);
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/' . $cmd . '.php');
    include(PATH . 'content/footer.php');
    break;

  // Export contacts..
  case 'contacts':

    isSessionActive();

    $title = $title . ' - ' . $msg_survey51;

    // Clear results..
    if (isset($_GET['clear'])) {
      include(PATH . 'control/classes/class.surveys.php');
      $SVY = new surveys();
      $SVY->clearContacts($_GET['survey']);
      include(PATH . 'content/header.php');
      include(PATH . 'content/clear-contacts.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    if (isset($_POST['process'])) {
      // If survey array is empty, set default..
      if (!isset($_POST['survey'])) {
        $_POST['survey']   = [];
        $_POST['survey'][] = 'all';
      }
      // Make sure we have a seperator..
      $sep = ($_POST['seperator'] ? $_POST['seperator'] : ',');
      // Define id numbers. All overwrites id selections..
      $ids = (in_array('all', $_POST['survey']) ? 'all' : implode(",", $_POST['survey']));
      // Download...
      $STS->importFileCSV($msg_contacts6, $msg_contacts7, $sep, $ids, $msg_javascript11);
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/contacts.php');
    include(PATH . 'content/footer.php');
    break;

  // Keyword analysis..
  case 'keywords':

    isSessionActive();

    include(PATH . 'control/classes/class.keywords.php');
    $KEY = new keywords();

    // Clear keywords..
    if (isset($_GET['clear'])) {
      $KEY->clearKeywords();
      $title = $title . ' - ' . $msg_survey52;
      include(PATH . 'content/header.php');
      include(PATH . 'content/clear-keywords.php');
      include(PATH . 'content/footer.php');
      exit;
    }
    // Print keywords..
    if (isset($_GET['print'])) {
      include(PATH . 'control/classes/class.surveys.php');
      $SVY = new surveys();
      include(PATH . 'content/popup/print.php');
      exit;
    }
    // View search for keyword..
    if (isset($_GET['search'])) {
      include(PATH . 'control/classes/class.surveys.php');
      $SVY = new surveys();
      include(PATH . 'content/popup/search.php');
      exit;
    }
    // Hide/show filter options..
    if (isset($_GET['hide']) || isset($_GET['show'])) {
      if (isset($_GET['hide'])) {
        $_SESSION['hide_filter'] = time();
      } else {
        unset($_SESSION['hide_filter']);
      }
      header("Location: index.php?cmd=keywords&survey=" . $_GET['survey'] . (isset($_GET['question']) ? '&question=' . cleanData($_GET['question']) : '') . (isset($_GET['from']) ? '&from=' . $_GET['from'] : '') . (isset($_GET['to']) ? '&to=' . $_GET['to'] : ''));
      exit;
    }

    $title = $title . ' - ' . $msg_survey52;

    include(PATH . 'content/header.php');
    include(PATH . 'content/keywords.php');
    include(PATH . 'content/footer.php');
    break;

  // Change Password..
  case 'pass':

    isSessionActive();

    $title = $title . ' - ' . $msg_header6;

    if (isset($_POST['process'])) {
      $_POST = array_map('trim', $_POST);
      if ($_POST['old'] == '') {
        $O_ERROR = $msg_pass5;
        $count++;
        $old = true;
      }
      if (!isset($old) && md5($_POST['old'] . SECRET_KEY) != $SETTINGS->cfg_password) {
        $O_ERROR = $msg_pass10;
        $count++;
      }
      if ($_POST['new1'] == '') {
        $N_ERROR = $msg_pass6;
        $count++;
        $new = true;
      }
      if (!isset($new) && $_POST['new1'] != $_POST['new2']) {
        $N2_ERROR = $msg_pass7;
        $count++;
      }
      if ($count == 0) {
        $STS->updatePassword($_POST['new1']);
        $CHANGED = true;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/pass.php');
    include(PATH . 'content/footer.php');
    break;

  // New Pass..
  case 'newpass':

    isSessionActive(true);

    $title = $title . ' - ' . $msg_login7;

    // Get new password..
    if (isset($_POST['process'])) {
      $username = $SETTINGS->cfg_login;
      $_POST    = array_map('trim', $_POST);
      if ($_POST['user'] != $username) {
        $U_ERROR = $msg_login12;
        $count++;
      }
      if ($_POST['email'] != $SETTINGS->cfg_wemail) {
        $E_ERROR = $msg_login15;
        $count++;
      }
      if ($count == 0) {
        $newpass = substr(md5(uniqid(rand(), 1)), 2, 10);
        $STS->updatePassword($newpass);
        $MAIL->addTag('{PASS}', $newpass);
        $MAIL->addTag('{NAME}', $username);
        $MAIL->addTag('{URL}', $SETTINGS->cfg_wurl . 'admin/index.php?cmd=login');
        $MAIL->sendMail(
          $SETTINGS->cfg_wemail,
          $SETTINGS->cfg_wname,
          $SETTINGS->cfg_wemail,
          $msg_login16,
          $MAIL->template(IPATH . 'content/lang/email/new_pass.txt')
        );
        $SENT = true;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/newpass.php');
    include(PATH . 'content/footer.php');
    break;

  // Login..
  case 'login':

    isSessionActive(true);

    $title = $title . ' - ' . $msg_header2;

    // Login..
    if (isset($_POST['process'])) {
      $username = $SETTINGS->cfg_login;
      $password = $SETTINGS->cfg_password;
      $_POST    = array_map('trim', $_POST);
      if ($_POST['user'] != $username) {
        $U_ERROR = $msg_login12;
        $count++;
      }
      if (md5($_POST['pass'] . SECRET_KEY) != $password) {
        $P_ERROR = $msg_login13;
        $count++;
      }
      if ($count == 0) {
        $_SESSION[SEC_TOKEN] = md5($_POST['user']) . time();
        if (isset($_POST['cookie'])) {
          setcookie(COOKIE_NAME, md5(SECRET_KEY), time() + 60 * 60 * 24 * 30);
        }
        header("Location: index.php");
        exit;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/login.php');
    include(PATH . 'content/footer.php');
    break;

  // Logout..
  case 'logout':

    session_unset();
    session_destroy();
    setcookie('PHPSESSID', 0, time() - 3600);
    
    unset($_SESSION);

    if (isset($_COOKIE[COOKIE_NAME])) {
      @setcookie(COOKIE_NAME, '');
      unset($_COOKIE);
    }

    header("Location: index.php?cmd=login");
    break;

  default:
    header("Location: index.php");
    break;
}

?>