<?php

define('SYS_ROOT_PATH', __dir__ . '/../../../');
include(SYS_ROOT_PATH . 'control/classes/mailer/src/Exception.php');
include(SYS_ROOT_PATH . 'control/classes/mailer/src/SMTP.php');
include(SYS_ROOT_PATH . 'control/classes/mailer/src/PHPMailer.php');

class mailClass extends PHPMailer\PHPMailer\PHPMailer {

  public $vars = array();
  public $smtp_host;
  public $smtp_port;
  public $smtp_user;
  public $smtp_pass;
  public $smtp_en;
  public $html = false; // Set to true to use HTML in e-mail templates
  public $smtp_sec = ''; // tls, ssl or blank

  // Mail debug log..
  private $debug = 'no';
  private $debug_log_file = 'mail-debug-log.log';

  // Allow insecure connections..
  // Use at your own risk..
  // yes or no value
  private $allowInsecure = 'no';
  
  // Preferred language
  // Must be supported language
  private $mail_lang = 'en';

  public function cleanData($data) {
    return $data;
  }

  public function convertChar($data) {
    $find    = array('&#039;','&quot;','&amp;','&lt;','&gt;');
    $replace = array('\'','"','&','<','>');

    return str_replace($find,$replace,$data);
  }

  public function addTag($placeholder,$data) {
    $this->vars[$placeholder] = $data;
  }

  public function clearVars() {
    $this->vars = array();
  }

  public function convertTags($data) {
    if (!empty($this->vars)) {
      foreach ($this->vars AS $tags => $value) {
        $data = str_replace($tags,$value,$data);
      }
    }
    return trim($data);
  }

  public function mailHeaders($name,$email) {
    global $mail_charset;
    if ($this->html) {
      $headers  = "Content-type: text/html; charset=" . $mail_charset."\r\n";
      $headers .= "From: \"" . $this->injectionCleaner($name)."\" <" . $email.">\n";
    } else {
      $headers  = "Content-type: text/plain; charset=" . $mail_charset."\r\n";
    $headers .= "From: \"" . $this->injectionCleaner($name)."\" <" . $email.">\n";
    }
    $headers .= "X-Sender: \"" . $this->injectionCleaner($name)."\" <" . $email.">\n";
    $headers .= "X-Mailer: PHP\n";
    $headers .= "X-Priority: 3\n";
    $headers .= "X-Sender-IP: " . $_SERVER['REMOTE_ADDR']."\n";
    $headers .= "Return-Path: \"" . $this->injectionCleaner($name)."\" <" . $email.">\n";
    $headers .= "Reply-To: \"" . $this->injectionCleaner($name)."\" <" . $email.">\n";

    return $headers;
  }

  public function injectionCleaner($data) {
    $find     = array(
     "\r",
     "\n",
     "%0a",
     "%0d",
     "content-type:",
     "Content-Type:",
     "BCC:",
     "CC:",
     "TO:",
     "bcc:",
     "to:",
     "cc:"
     );
    $replace  = array();
    return str_replace($find,$replace,$data);
  }

  public function template($file) {
    $email_string = file_get_contents($file);
    if ($email_string) {
      return $this->convertTags(trim($email_string));
    } else {
      die("An error occurred opening the <b>'$file'</b> file. Check that this file exists in the 'content/lang/email/' folder!");
    }
  }

  public function sendMail($addresses,$from_name,$from_email,$subject,$msg,$email=true) {
    if ($email) {
      if ($this->smtp_en) {
        $this->IsSMTP();
        $this->IsHTML($this->html);
        $this->Port         = $this->smtp_port;
        $this->Host         = $this->smtp_host;
        $this->SMTPAuth     = ($this->smtp_user && $this->smtp_pass ? true : false);
        $this->SMTPSecure = (in_array($this->smtp_sec, array(
          '',
          'tls',
          'ssl'
        )) ? $this->smtp_sec : '');
        // Allow insecure connections?
        if ($this->allowInsecure == 'yes') {
          $this->SMTPOptions = array(
            'ssl' => array(
              'verify_peer' => false,
              'verify_peer_name' => false,
              'allow_self_signed' => true
            )
          );
        }
        $this->Username     = $this->smtp_user;
        $this->Password     = $this->smtp_pass;
        $this->From         = $from_email;
        $this->FromName     = $this->convertChar($this->cleanData($this->injectionCleaner($from_name)));
        if (is_array($addresses) && !empty($addresses)) {
          foreach ($addresses AS $to_email) {
            $this->AddAddress($to_email, $this->convertChar($this->cleanData($this->injectionCleaner($to_email))));
          }
        } else {
          $this->AddAddress($addresses, $this->convertChar($this->cleanData($this->injectionCleaner($addresses))));
        }
        $this->WordWrap     = 1000;
        $this->CharSet      = 'utf-8';
        // Enable debug..
        if ($this->debug == 'yes') {
          $this->SMTPDebug = 2;
          $this->Debugoutput = function($str, $level) {
            file_put_contents(SYS_ROOT_PATH . 'logs/' . $this->debug_log_file, $str . PHP_EOL, FILE_APPEND);
          };
        }
        $this->ContentType  = (SET_HTML ? 'text/html' : 'text/plain');
        $this->Subject      = $this->convertChar($this->cleanData($subject));
        $this->Body         = $this->convertChar($this->cleanData($msg));
        // Language
        if ($this->mail_lang != 'en') {
          $this->setLanguage($this->mail_lang, SYS_ROOT_PATH . 'control/classes/mailer/language/');
        }
        $this->Send();
      } else {
        mail(
          (is_array($addresses) ? implode(',',$addresses) : $addresses),
          $this->convertChar($this->cleanData($subject)),
          $this->convertChar($this->cleanData($msg)),
          $this->mailHeaders($this->cleanData($this->convertChar($from_name)),$from_email)
        );
      }
    }
  }

}

?>
