<?php

// Catch MySQL errors..
function db_MSG($file,$line) {
  echo '<p style="color:red;border:2px solid red;padding:10px;font-size:12px;line-height:20px;background:#f2f2f2">';
  echo '<b style="color:black">MYSQL DATABASE ERROR:</b><br />';
  echo '<b>Code</b>: '.((is_object($GLOBALS["___mysqli_ston"])) ? mysqli_errno($GLOBALS["___mysqli_ston"]) : (($___mysqli_res = mysqli_connect_errno()) ? $___mysqli_res : false)).'<br />';
  echo '<b>Error</b>: '.((is_object($GLOBALS["___mysqli_ston"])) ? mysqli_error($GLOBALS["___mysqli_ston"]) : (($___mysqli_res = mysqli_connect_error()) ? $___mysqli_res : false)).'<br />';
  echo '<b>File</b>: '.$file.'<br />';
  echo '<b>Line</b>: '.$line.'<br />';
  echo '</p>';
  exit;
}

// Show help tip..
function showHelpTip($id,$count='') {
  global $QUE,$msg_script14;
  $string = '';
  if ($QUE->que_help_text) {
    $string = ' <a href="index.php?help='.$id.'&amp;width='.TOOLTIP_WIDTH.'" class="jTip" id="two'.($count ? $count : '').'" rel="'.$msg_script14.'"><img style="vertical-align:bottom" src="content/images/help.png" alt="" title="" /></a>';
  }
  return $string;
}

// Show footer data..total questions..progress bar..
function showSurveyFooterInformation() {
  global $SURVEY,$public_buttons3,$webSurvey;

  // Calculate percentage for progress bar..
  $cells  = ceil(100/$SURVEY->getSurveyQuestionCount($webSurvey->sur_id));

  // Question count..
  $count = (isset($_SESSION['question_slot']) && $_SESSION['question_slot']>0 ? ($_SESSION['question_slot']+1) : '1');
  $width  = ($count==1 ? '1%' : $cells*($count-1).'%');

  // Progress bar..
  $pBar = str_replace(array('{width}','{start}'),array($width,($width=='1%' ? 'Hidden' : '')),file_get_contents(PATH.'content/html/progress_bar.tpl'));

  return str_replace("{count}",$SURVEY->getSurveyQuestionCount($webSurvey->sur_id),$public_buttons3).'
         ('.$count.'/'.$SURVEY->getSurveyQuestionCount($webSurvey->sur_id).')'.$pBar;
}

// Render survey title..
function showSurveyTitle($title=false) {
  global $webSurvey,$public_results;

  $string = '';
  if (isset($webSurvey) && $webSurvey->sur_title_should_display) {
    $string = str_replace('{title}',cleanData($webSurvey->sur_title),file_get_contents(PATH.'content/html/title.tpl'));
  }
  return ($title ? cleanData($webSurvey->sur_title) : $string);
}

// Render print bar..
function showPrintBar() {
  global $public_results2,$public_results3,$SURVEY,$webSurvey,$public_results;
  return str_replace(array('{print}','{people}','{results}'),array($public_results3,str_replace("{count}",$SURVEY->getParticipantCount($webSurvey->sur_id),$public_results2),$public_results),file_get_contents(PATH.'content/html/print_bar.tpl'));
}

// Render survey title..
function showSurveyEmailMessage() {
  global $webSurvey;
  $string = '';
  if (isset($webSurvey) && $webSurvey->sur_email_request_message) {
    $string = str_replace('{title}',cleanData(nl2br($webSurvey->sur_email_request_message)),file_get_contents(PATH.'content/html/email_text.tpl'));
  }
  return $string;
}

// Recursive way of handling multi dimensional arrays to mimic array map..
// We don`t use the clear option in ISS..in case you were wondering..
function multiDimensionalArrayMap($func,$arr) {
  $newArr = [];
  if (!empty($arr)) {
    foreach($arr AS $key => $value) {
      $newArr[$key] = (is_array($value) ? multiDimensionalArrayMap($func,$value) : $func($value));
    }
  }
  return $newArr;
}

// Removes potential harmful tags
function cleanEvilTags($data) {
  $data = preg_replace("/javascript/i", "j&#097;v&#097;script",$data);
  $data = preg_replace("/alert/i", "&#097;lert",$data);
  $data = preg_replace("/about:/i", "&#097;bout:",$data);
  $data = preg_replace("/onmouseover/i", "&#111;nmouseover",$data);
  $data = preg_replace("/onclick/i", "&#111;nclick",$data);
  $data = preg_replace("/onload/i", "&#111;nload",$data);
  $data = preg_replace("/onsubmit/i", "&#111;nsubmit",$data);
  $data = preg_replace("/<body/i", "&lt;body",$data);
  $data = preg_replace("/<html/i", "&lt;html",$data);
  $data = preg_replace("/document\./i", "&#100;ocument.",$data);
  return trim((string) strip_tags((string) $data));
}

// Load previous button if not first page..
function loadPreviousButton($page) {
  global $public_buttons;
  return str_replace(array('{previous}','{page}'),array($public_buttons,$page),file_get_contents(PATH.'content/html/previous.tpl'));
}

// Load settings..
function loadSettings() {
  global $database;
  $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM `".DB_PREFIX."config` LIMIT 1") or die(db_MSG(__FILE__,__LINE__));
  return mysqli_fetch_object($query);
}

// Table count..
function mysqlTableCount($table,$query='',$row='count(*) AS `r_count`',$num=false) {
  global $database;
  $count = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT " . $row." FROM ".DB_PREFIX.$table.$query."") or die(db_MSG(__FILE__,__LINE__));
  if ($num) {
    return mysqli_num_rows($count);
  } else {
    $COUNT = mysqli_fetch_object($count);
    return $COUNT->r_count;
  }
}

// Strip html
function cleanDataEnt($data) {
  if (is_array($data)) {
    return mswMDAM('htmlspecialchars', $data);
  } else {
    $data = htmlspecialchars($data);
    $data = str_replace('&amp;#','&#',$data);
    $data = str_replace('&amp;amp;','&amp;',$data);
  }
  return cleanData($data);
}

function mswMDAM($func, $arr) {
  $newArr = [];
  if (!empty($arr)) {
    foreach ($arr AS $key => $value) {
      $newArr[$key] = (is_array($value) ? mswMDAM($func, $value) : $func($value));
    }
  }
  return $newArr;
}

// Clean data..
function cleanData($data) {
  return $data;
}

// Define new line character..
function mswNL($br = 1) {
  if ($br > 1) {
    return str_repeat(PHP_EOL, $br);
  }
  return PHP_EOL;
}

// Remove double apostrophes via magic quotes setting..
function removeDoubleApostrophes($data) {
  return str_replace("''","'",$data);
}

//---------------------------------------------------
// Gets visitor IP address..
//---------------------------------------------------

function getRealIPAddr() {
  $ips = [];
  $types = array(
    'HTTP_CLIENT_IP',
    'HTTP_X_FORWARDED_FOR',
    'HTTP_X_FORWARDED',
    'HTTP_X_CLUSTER_CLIENT_IP',
    'HTTP_FORWARDED_FOR',
    'HTTP_FORWARDED',
    'REMOTE_ADDR'
  );
  foreach ($types AS $key) {
    if (array_key_exists($key, $_SERVER) === true) {
      foreach (array_map('trim', explode(',', $_SERVER[$key])) AS $ipA) {
        if (!in_array($ipA, $ips) && filter_var($ipA, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE) !== false) {
          $ips[] = $ipA;
        } else {
          // Double check for localhost..
          if (!in_array($ipA, $ips) && in_array($ipA, array('::1','127.0.0.1'))) {
            $ips[] = $ipA;
          }
        }
      }
    }
  }
  return (!empty($ips) ? implode(',', $ips) : '');
}

function safeImport($data) {
  if (is_array($data)) {
    $data = multiDimensionalArrayMap('mysql_real_escape_string',$data);
  } else {
    $data = ((isset($GLOBALS["___mysqli_ston"]) && is_object($GLOBALS["___mysqli_ston"])) ? mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $data) : ((trigger_error("[MySQLConverterToo] Fix the mysql_escape_string() call! This code does not work.", E_USER_ERROR)) ? "" : ""));
  }
  return $data;
}

// Get browser type..
function get_browser_type() {
  $agent = 'IE';
  if (isset($_SERVER['HTTP_USER_AGENT'])) {
    if (strpos(strtoupper($_SERVER['HTTP_USER_AGENT']),'OPERA')!==FALSE) {
      $agent = 'OPERA';
    } elseif (strpos(strtoupper($_SERVER['HTTP_USER_AGENT']),'MSIE')!==FALSE) {
      $agent = 'IE';
    } elseif (strpos(strtoupper($_SERVER['HTTP_USER_AGENT']),'OMNIWEB')!==FALSE) {
      $agent = 'OMNIWEB';
    } elseif (strpos(strtoupper($_SERVER['HTTP_USER_AGENT']),'MOZILLA')!==FALSE) {
      $agent = 'MOZILLA';
    } elseif (strpos(strtoupper($_SERVER['HTTP_USER_AGENT']),'KONQUEROR')!==FALSE) {
      $agent = 'KONQUEROR';
    } else {
      $agent = 'OTHER';
    }
  }
  return $agent;
}

// Get mime type..
function get_mime_type() {
  $agent = get_browser_type();
  $mime_type = ($agent == 'IE' || $agent == 'OPERA')
  ? 'application/octetstream'
  : 'application/octet-stream';
  return $mime_type;
}

// Sanitize data..
// Clean date vars..
$_GET = array_map('htmlspecialchars',$_GET);
if (isset($_GET['from']) && $_GET['from'] && strtotime($_GET['from'])==0) {
  $_GET['from'] = '0000-00-00';
}
if (isset($_GET['to']) && $_GET['to'] && strtotime($_GET['to'])==0) {
  $_GET['to'] = '0000-00-00';
}

?>