<?php

/* SOFTWARE LOADER
   DO NOT change this file
----------------------------------*/

// Set paths..
define('PATH', __dir__.'/');
define('INC',1);
define('RESULTS_DATA',1);

include(PATH . 'control/classes/class.errors.php');
if (ERR_HANDLER_ENABLED) {
  register_shutdown_function('msFatalErr');
  set_error_handler('msErrorhandler');
}

// Load get vars..
$code   = isset($_GET['survey']) ? $_GET['survey'] : '';
$count  = 0;
$sData  = '';

if(file_exists(PATH . 'control/_cfg.php')){include(PATH . 'control/_cfg.php');}else{die('File "control/_cfg.php" is missing, please see installation instructions.');}

if (version_compare(PHP_VERSION, '8.0.0') >= 0) {
  include(PATH . 'control/lib/tracy/vendor/tracy/tracy/src/tracy.php');
}
use Tracy\Debugger;
if (version_compare(PHP_VERSION, '8.0.0') >= 0) {
  // For development, report everything and enable tracy bar
  Debugger::$showBar = (defined('DEVELOPMENT_ENV') ? true : false);
  Debugger::$strictMode = (defined('DEVELOPMENT_ENV') ? true : false);
  Debugger::enable(Debugger::DEVELOPMENT, PATH . 'logs');
}

include(PATH . 'content/lang/english.php');
include(PATH . 'control/functions.php');
include(PATH . 'control/defined.php');
include(PATH . 'control/classes/class.survey.php');
include(PATH . 'control/classes/class.results.php');
include(PATH . 'control/lib/Savant3.php');

// Unicode stuff..
@mysqli_query($GLOBALS["___mysqli_ston"], "SET CHARACTER SET 'utf8'");
@mysqli_query($GLOBALS["___mysqli_ston"], "SET NAMES 'utf8'");

// Set timezone..
date_default_timezone_set((TIMEZONE ? TIMEZONE : date_default_timezone_get()));

// Initiate settings class..
$SETTINGS = loadSettings();

// Check var if reloading from admin..
if (isset($_GET['survey']) && strlen($_GET['survey'])>33) {
  $split = explode("-",$_GET['survey']);
  if (md5($SETTINGS->cfg_login)==$split[0]) {
    $code = substr($_GET['survey'],33,strlen($_GET['survey']));
    $_SESSION['admin_status'] = time();
  }
}

$SURVEY           = new webSurvey();
$RESULTS          = new webSurveyResults();
$SURVEY->survey   = $code;
$RESULTS->survey  = $code;

// Load survey vars into array..
$webSurvey        = $SURVEY->loadSurvey();

// Check survey..
// If invalid code, show error..
if (!$SURVEY->checkSurveyExists() || $code=='' && (!isset($_SESSION['admin_status']))) {
  header("Location: index.php?code=" . $code."&error=" . ($code=='' ? 'no_code' : 'invalid'));
  exit;
}

// Check survey expiry date...
if ($SURVEY->checkSurveyExpiryDate() && (!isset($_SESSION['admin_status']))) {
  header("Location: index.php?code=" . $code."&error=expired");
  exit;
}

// Can visitor view this survey?
if (!$webSurvey->sur_view_summary && (!isset($_SESSION['admin_status']))) {
  header("Location: index.php?code=" . $code."&error=no_view");
  exit;
}

// Are we loading pop up screen?
if (isset($_GET['other'])) {
  $QUE    = $SURVEY->getQuestion($_GET['other']);
  $qdata  = '';
  // Load unique answers for this question..
  $query = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT DISTINCT(`ans_text`) FROM `".DB_PREFIX."answers`
           WHERE `ans_que_id`  = '".(int)$_GET['other']."'
           AND `ans_var_id`    = '0'
           ORDER BY `ans_id`
           ") or die(db_MSG(__FILE__,__LINE__));
  while ($ANS = mysqli_fetch_object($query)) {
    if ($ANS->ans_text) {
      // Get count of other answers for this question...
      $tCount      = mysqli_num_rows($query);
      // How many times does this answer occur..
      $qCount      = mysqlTableCount('answers',' WHERE ans_text = \''.safeImport($ANS->ans_text).'\'');
      // Calculate percentage..
      $percentage  = number_format((float) $qCount/$tCount*100,1).'%';
      $qdata      .= str_replace(
        array('{answer}','{percentage}'),
        array(nl2br(cleanDataEnt($ANS->ans_text)),$percentage.' ('.$qCount.')'),
        file_get_contents(PATH.'content/html/result_type_other_answer.tpl')
      );
    }
  }
  // Any data??
  if ($qdata=='') {
    $qdata .= str_replace(array('{answer}','{percentage}'),array($public_results10,''),file_get_contents(PATH.'content/html/result_type_other_answer.tpl'));
  }
  // Load question..
  $load  = str_replace(
    array('{question}','{answer}','{back}'),
    array(cleanDataEnt($QUE->que_text).' ('.$public_results4.')',$qdata,$msg_script20),
    file_get_contents(PATH.'content/html/result_type_other_question.tpl')
  );
  // If we are still here, we can view the survey results..
  include(PATH.'control/header.php');
  $tpl = new Savant3();
  $tpl->assign('PRINT',showPrintBar());
  $tpl->assign('TITLE',showSurveyTitle(false));
  $tpl->assign('SURVEY_RESULTS',$load);
  $tpl->display('content/other_results.tpl.php');
  include(PATH.'control/footer.php');
} else {
  // Load survey questions into array...
  $webSurveyQuestions  = $SURVEY->loadSurveyQuestions($webSurvey->sur_id);

  // Loop through questions..
  foreach ($webSurveyQuestions AS $id) {
    // Get question..
    $QUE      = $SURVEY->getQuestion($id);
    $find     = array('{question}','{question_data}');
    $replace  = array(cleanDataEnt($QUE->que_text),$RESULTS->showQuestionSurveyResults($QUE->que_answer_type,$QUE->que_id,$public_results4,$public_results5,$public_results6,$public_results7,$public_results8));
    $sData    .= str_replace($find,$replace,file_get_contents(PATH.'content/html/single_question_result.tpl'));
  }

  // If we are still here, we can view the survey results..
  include(PATH.'control/header.php');
  $tpl = new Savant3();
  $tpl->assign('PRINT',showPrintBar());
  $tpl->assign('TITLE',showSurveyTitle(false));
  $tpl->assign('SURVEY_RESULTS',$sData);
  $tpl->display('content/results.tpl.php');
  include(PATH.'control/footer.php');
}

?>
